package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WXMedia;
import com.sa.ibiz.demo.demo.service.WXMediaService;
import com.sa.ibiz.demo.demo.service.dto.WXMediaSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wxmedia")
public class WXMediaResource
{
	@Autowired
	private WXMediaService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WXMedia> update(@Validated @RequestBody WXMedia data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("微信多媒体内容[update]操作发生错误","WXMedia",data.getWxmediaid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WXMedia> create(@Validated @RequestBody WXMedia data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("微信多媒体内容[create]操作发生错误","WXMedia",data.getWxmediaid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WXMedia> checkKey(@Validated @RequestBody WXMedia data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("微信多媒体内容[checkKey]操作发生错误","WXMedia",data.getWxmediaid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WXMedia> get(@Validated @PathVariable String id){
		WXMedia data=new WXMedia();
		data.setWxmediaid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("微信多媒体内容[get]操作发生错误","WXMedia",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WXMedia> getDraft(@Validated @RequestBody WXMedia data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("微信多媒体内容[getDraft]操作发生错误","WXMedia","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WXMedia> remove(@Validated @RequestBody WXMedia data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("微信多媒体内容[remove]操作发生错误","WXMedia",data.getWxmediaid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WXMedia>> searchDefaultPage(@Validated @RequestBody WXMediaSearchFilter filter){
		Page<WXMedia> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WXMedia>> listDefault(@Validated @RequestBody WXMediaSearchFilter filter){
		List<WXMedia> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
